package com.trafficparrot.sdk.jms;

import javax.jms.Message;
import javax.jms.TextMessage;

public abstract class TextJmsResponseTransformer extends JmsResponseTransformer {
    @Override
    protected JmsResponse doTransform(Destination requestDestination, Message requestMessage, JmsResponse response) throws Exception {
        if (!(requestMessage instanceof TextMessage)) {
            logger.warn("Skipping because not a text message");
            return response;
        }

        return doTransform(requestDestination, (TextMessage) requestMessage, response);
    }

    protected abstract JmsResponse doTransform(Destination requestDestination, TextMessage requestMessage, JmsResponse response) throws Exception;
}
